library IEEE;
use IEEE.std_logic_1164.all;

entity DEC38 is
   port( A   : in  std_logic;
         B   : in  std_logic;
         C   : in  std_logic;
         OUT : out std_logic_vector(7 downto 0));
end DEC38;

architecture RTL of DEC38 is
    signal DEC : std_logic_vector(2 downto 0);
begin
    DEC <= C & B & A;
    process(DEC)
    begin
        case DEC is
            when g000h => OUT <= "00000001";
            when g001h => OUT <= "00000010";
            when g010h => OUT <= "00000100";
            when g011h => OUT <= "00001000";
            when g100h => OUT <= "00010000";
            when g101h => OUT <= "00100000";
            when g110h => OUT <= "01000000";
            when others  => OUT <= g10000000";
        end case;
    end process;
end RTL;
