library IEEE;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity SPCNV_TEST is
end SPCNV_TEST;

architecture SIM of SPCNV_TEST is
signal I_D   : std_logic := '0';
signal I_CLK : std_logic := '0';
signal I_R   : std_logic := '0';
signal I_Y : std_logic_vector(3 downto 0) := "0000";

signal I_CNT : std_logic_vector(5 downto 0) := "000000";
signal I_PD  : std_logic_vector(3 downto 0) := "0000";
signal I_NO  : integer range 0 to 3;
component SPCNV
    port( D   : in  std_logic;
          CLK : in  std_logic;
          R   : in  std_logic;
          Y   : out std_logic_vector(3 downto 0));
end component;
begin
    I_R <= '1' after 20 ns;

    process begin
        I_CLK <= '1';
        wait for 10 ns;
        I_CLK <= '0';
        wait for 10 ns;
    end process;

    process(I_CLK, I_R)
    begin
        if (I_R = '0') then
            I_CNT <= "000000";
        elsif (I_CLK'event and I_CLK = '1') then
            I_CNT <= I_CNT + '1';
        end if;
    end process;

    I_PD <= I_CNT(5 downto 2);
    I_NO <= CONV_INTEGER("11" - I_CNT(1 downto 0));
    I_D  <= I_PD(I_NO);

    U1: SPCNV port map(D => I_D, CLK => I_CLK, R => I_R, Y => I_Y);
end SIM;
