library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity PSCNV is
    port( D   : in  std_logic_vector(3 downto 0);
          CLK : in  std_logic;
          R   : in  std_logic;
          Y   : out std_logic);
end PSCNV;

architecture RTL of PSCNV is
    signal REG   : std_logic_vector(3 downto 0);
    signal I_CNT : std_logic_vector(1 downto 0);
begin
    process(CLK, R)
    begin
        if (R = '0') then
            REG   <= "0000";
            I_CNT <= "00";
        elsif (CLK'event and CLK = '1') then
            if (I_CNT = "00") then
                REG <= D;
            else
                REG <= REG(2 downto 0) & '0';
            end if;
            I_CNT <= I_CNT + '1';
       end if;
    end process;

    Y <= REG(3);
end RTL;
