library IEEE;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity PSCNV_TEST is
end PSCNV_TEST;

architecture SIM of PSCNV_TEST is
signal I_D   : std_logic_vector(3 downto 0) := "0000";
signal I_CLK : std_logic := '0';
signal I_R   : std_logic := '0';
signal I_Y   : std_logic := '0';
signal I_CNT : std_logic_vector(5 downto 0) := "000000";
component PSCNV
    port( D   : in  std_logic_vector(3 downto 0);
          CLK : in  std_logic;
          R   : in  std_logic;
          Y   : out std_logic);
end component;
begin
    I_R <= '1' after 20 ns;

    process begin
        I_CLK <= '1';
        wait for 10 ns;
        I_CLK <= '0';
        wait for 10 ns;
    end process;

    process(I_CLK, I_R)
    begin
        if (I_R = '0') then
            I_CNT <= (others => '0');
        elsif I_CLK'event and I_CLK = '1' then
            I_CNT <= I_CNT + '1';
        end if;
    end process;

    I_D  <= I_CNT(5 downto 2);

    U1: PSCNV port map(D => I_D, CLK => I_CLK, R => I_R, Y => I_Y);
end SIM;
