library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity CUTCHAT is
    port( CLK : in  std_logic;    -- 1MHzNbN
          SW  : in  std_logic;
          R   : in  std_logic;
          SSW : out std_logic);
end CUTCHAT;

architecture RTL of CUTCHAT is
    signal REG : std_logic_vector(3 downto 0);
    signal CNT : integer range 0 to 10000;
begin
    process(CLK, R)
    begin
        if (R = '0') then
            REG <= "1111";
            CNT <= 0;
        elsif (CLK'event and CLK = '1') then
            if (CNT = 10000) then
                CNT <= 0;
                REG <= REG(2 downto 0) & SW;
            else
                CNT <= CNT + 1;
            end if;
        end if;
    end process;

    SSW <= REG(3) or REG(2) or REG(1) or REG(0);
end RTL;
