library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity FULLCNT is
    generic( MODE : string(1 to 3) := "RTL");
    port( CLK : in  std_logic;
          R   : in  std_logic;
          D   : in  std_logic;
          FULL : out std_logic);
end FULLCNT;

architecture RTL of FULLCNT is
    signal CNT : integer range 0 to 10;
begin
RTLMODE: if (MODE = "RTL") generate    -- FPGAɏގۂ̉H
    process(CLK, R)
    begin
        if (R = '0') then
            CNT  <= 0;
            FULL <= '0';
        elsif (CLK'event and CLK = '1') then
            if (D = '1') then
                if (CNT < 10) then
                    CNT <= CNT + 1;
                end if;
                if (CNT >= 9) then
                    FULL <= '1';
                end if;
            end if;
        end if;
    end process;
end generate;

SIMMODE: if (MODE /= "RTL") generate   -- V~[Vp̉H
    process(CLK, R)
    begin
        if (R = '0') then
            CNT  <= 0;
            FULL <= '0';
        elsif (CLK'event and CLK = '1') then
            if (D = '1') then
                if (CNT < 10) then
                    CNT <= CNT + 1;
                end if;
                assert (CNT < 9)
                report "FULL COUNT."
                severity FAILURE;
            end if;
        end if;
    end process;
end generate;

end RTL;
