library IEEE;
use ieee.std_logic_1164.all;

entity FULLCNT_TEST is
end FULLCNT_TEST;

architecture SIM of FULLCNT_TEST is
    signal I_CLK : std_logic := '1';
    signal I_R   : std_logic := '0';
    signal I_D   : std_logic_vector(8 downto 0) := "010100110";
    signal I_D2  : std_logic;
    signal C     : integer range 0 to 8 := 0;
component FULLCNT
	generic( MODE : string(1 to 3) := "RTL");
    port( CLK : in  std_logic;
          R   : in  std_logic;
          D   : in  std_logic;
          FULL : out std_logic);
end component;
begin
    I_R <= '1' after 10 ns;

    process begin
        I_CLK <= '1';
        wait for 10 ns;
        I_CLK <= '0';
        wait for 10 ns;
    end process;

    process(I_CLK)
    begin
        if (I_CLK'event and I_CLK = '1') then
            if (C = 8) then
                C <= 0;
            else
                C <= C + 1;
            end if;
        end if;
    end process;

    I_D2 <= I_D(C);

    U1: FULLCNT generic map(MODE => "RTL")
                port map(CLK => I_CLK, R => I_R, D => I_D2, FULL => open);
end SIM;
