library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity PULSE4 is
    port( CLK : in  std_logic;
          R   : in  std_logic;
          Y   : out std_logic);
end PULSE4;

architecture RTL of PULSE4 is
    signal CNT : std_logic_vector(3 downto 0);
begin
    Y <= '1' when CNT = "1100" else
         '1' when CNT = "1101" else
         '1' when CNT = "1110" else
         '1' when CNT = "1111" else
         '0';

    process(CLK, R)
    begin
        if (R = '0') then
            CNT <= "0000";
        elsif (CLK'event and CLK = '1') then
            CNT <= CNT + '1';
        end if;
    end process;
end RTL;
