library IEEE;
use ieee.std_logic_1164.all;

entity PULSE4_TEST is
end PULSE4_TEST;

architecture SIM of PULSE4_TEST is
    signal I_CLK : std_logic := '1';
    signal I_R   : std_logic := '0';
    signal I_Y   : std_logic := '0';
    signal TRISE : time      := 0 ps;
component PULSE4
    port( CLK : in  std_logic;
          R   : in  std_logic;
          Y   : out std_logic);
end component;
begin
    I_R <= '1' after 10 ns;

    process begin
        I_CLK <= '1';
        wait for 10 ns;
        I_CLK <= '0';
        wait for 10 ns;
    end process;

    process(I_Y)
    begin
        if (I_Y = '1') then
            TRISE <= NOW;
        else
            if (NOW > 0 ps) then
                assert (NOW - TRISE >= 80 ns)
                report "PULSE WIDTH ERROR!"
                severity FAILURE;
            end if;
        end if;
    end process;

    U1: PULSE4 port map(CLK => I_CLK, R => I_R, Y => I_Y);
end SIM;
