library IEEE;
use IEEE.std_logic_1164.all;

entity SHIFTREG is
    generic( X : integer := 4);
    port( CLK  : in  std_logic;
          DIN  : in  std_logic;
          DOUT : out std_logic);
end SHIFTREG;

architecture RTL of SHIFTREG is
    signal REG : std_logic_vector(X-1 downto 0);
begin
    process(CLK)
    begin
        if (CLK'event and CLK = '1') then
            REG <= REG(X-2 downto 0) & DIN;
        end if;
    end process;
    DOUT <= REG(X-1);
end RTL;
