library IEEE;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity SHIFTREG_TEST is
end SHIFTREG_TEST;

architecture SIM of SHIFTREG_TEST is
signal I_CLK   : std_logic := '0';
signal I_DIN   : std_logic := '0';
signal I_DOUT1 : std_logic := '0';
signal I_DOUT2 : std_logic := '0';
signal I_CNT   : integer range 0 to 15 := 0;
signal I_DATA  : std_logic_vector(15 downto 0) := "0001100110010100";
component SHIFTREG
    generic( X : integer := 4);
    port( CLK  : in  std_logic;
          DIN  : in  std_logic;
          DOUT : out std_logic);
end component;
begin

    process begin
        I_CLK <= '1';
        wait for 10 ns;
        I_CLK <= '0';
        wait for 10 ns;
    end process;

	process(I_CLK)
    begin
        if (I_CLK'event and I_CLK = '1') then
            if (I_CNT /= 15) then
                I_CNT <= I_CNT + 1;
            end if;
        end if;
    end process;

    I_DIN <= I_DATA(I_CNT);

    U1: SHIFTREG generic map(X => 4) port map(CLK => I_CLK, DIN => I_DIN, DOUT => I_DOUT1);
    U2: SHIFTREG generic map(X => 9) port map(CLK => I_CLK, DIN => I_DIN, DOUT => I_DOUT2);

end SIM;
