library IEEE,STD;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use std.TEXTIO.all;
use ieee.std_logic_textio.all;

entity MUL5_TEST is
end MUL5_TEST;

architecture SIM of MUL5_TEST is
    constant I_A : std_logic_vector(3 downto 0) := "0011";
    signal I_CLK : std_logic := '0';
    signal I_B   : std_logic_vector(3 downto 0) := "0001";
    signal I_X   : std_logic_vector(7 downto 0) := "00000000";
component MUL5
    port( A   : in  std_logic_vector(3 downto 0);
          B   : in  std_logic_vector(3 downto 0);
          X   : out std_logic_vector(7 downto 0));
end component;
begin
    process begin
        I_CLK <= '1';
        wait for 10 ns;
        I_CLK <= '0';
        wait for 10 ns;
    end process;

    process(I_CLK)
    begin
        if (I_CLK'event and I_CLK = '1') then
            if (I_B /= "1001") then
                I_B <= I_B + '1';
            end if;
        end if;
    end process;

    process(I_X)
    variable LO : line;
    begin
        hwrite(LO, I_A);
        write(LO, '*');
        hwrite(LO, I_B);
        write(LO, '=');
        hwrite(LO, I_X);
        writeline(OUTPUT, LO);
        if (I_B = "1001") then
            assert false
            report "end." severity FAILURE;
        end if;
    end process;

    U1: MUL5 port map(A => I_A, B => I_B, X => I_X);
end SIM;
