architecture RTL of TPU is
type FSMSTATE is (S_IDLE, S_NOP, S_DIN, S_OUT, S_MVB, S_MVA, S_MVF,
                  S_ADD, S_DIV1, S_DIV2, S_DIV3, S_SWP, S_EOS);
    signal STATE : FSMSTATE;
begin
    process(CLK, RST)
    begin
        if (RST = '0') then
            STATE <= S_IDLE;
            OUTPUT <= "00000000";
            OPACK  <= '0';
        elsif (CLK'event and CLK = '1') then
            OPACK <= '0';
            case STATE is
            when S_IDLE =>
                if (OPCS = '1') then
                    case OPCODE is
                        when "0000" => STATE <= S_NOP;
                    end case;
                end if;
            when S_NOP =>
                STATE <= S_EOS;
            when S_EOS =>
                OPACK <= '1';
                STATE <= S_IDLE;
            when others =>
                STATE <= S_IDLE;
            end case;
        end if;
    end process;
end RTL;
