library IEEE;
use ieee.std_logic_1164.all;

entity TPU_TEST is
end TPU_TEST;

architecture SIM of TPU_TEST is
    signal I_CLK    : std_logic := '1';
    signal I_R      : std_logic := '0';
    signal I_INPUT  : std_logic_vector(7 downto 0);
    signal I_OUTPUT : std_logic_vector(7 downto 0);
    signal I_OPCODE : std_logic_vector(3 downto 0);
    signal I_OPCS   : std_logic;
    signal I_OPACK  : std_logic;
component TPU
    port( CLK    : in  std_logic;
          RST    : in  std_logic;
          INPUT  : in  std_logic_vector(7 downto 0);
          OUTPUT : out std_logic_vector(7 downto 0);
          OPCODE : in  std_logic_vector(3 downto 0);
          OPCS   : in  std_logic;
          OPACK  : out std_logic);
end component;
component OPINF
    port( CLK    : in  std_logic;
          RST    : in  std_logic;
          INPUT  : out std_logic_vector(7 downto 0);
          OUTPUT : in  std_logic_vector(7 downto 0);
          OPCODE : out std_logic_vector(3 downto 0);
          OPCS   : out std_logic;
          OPACK  : in  std_logic);
end component;
begin
	I_R <= '1' after 10 ns;

    process begin
        I_CLK <='1';
        wait for 10 ns;
        I_CLK <='0';
        wait for 10 ns;
    end process;

    U1: TPU port map(CLK => I_CLK, RST => I_R,
                     INPUT => I_INPUT, OUTPUT => I_OUTPUT, OPCODE => I_OPCODE,
                     OPCS => I_OPCS, OPACK => I_OPACK);
    U2: OPINF port map(CLK => I_CLK, RST => I_R,
                     INPUT => I_INPUT, OUTPUT => I_OUTPUT, OPCODE => I_OPCODE,
                     OPCS => I_OPCS, OPACK => I_OPACK);
end SIM;
