library IEEE;
use IEEE.std_logic_1164.all;

entity ADD4 is
    port( A : in  std_logic_vector(3 downto 0);
          B : in  std_logic_vector(3 downto 0);
          S : out std_logic_vector(3 downto 0);
          C : out std_logic);
end ADD4;

architecture RTL of ADD4 is
signal I_S : std_logic_vector(3 downto 0);
signal I_C : std_logic_vector(3 downto 0);
component FADDER
    port( A : in  std_logic;
          B : in  std_logic;
          X : in  std_logic;
          S : out std_logic;
          C : out std_logic);
end component;
begin
    U1: FADDER port map(A => A(0),  B => B(0), X => '0',    S => I_S(0), C => I_C(0));
    U2: FADDER port map(A => A(1),  B => B(1), X => I_C(0), S => I_S(1), C => I_C(1));
    U3: FADDER port map(A => A(2),  B => B(2), X => I_C(1), S => I_S(2), C => I_C(2));
    U4: FADDER port map(A => A(3),  B => B(3), X => I_C(2), S => I_S(3), C => I_C(3));

    S <= I_S;
    C <= I_C(3);
end RTL;
