library IEEE,STD;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use std.TEXTIO.all;
use ieee.std_logic_textio.all;

entity ADD4_TEST is
end ADD4_TEST;

architecture SIM of ADD4_TEST is
    signal I_CLK : std_logic := '1';
    signal I_CNT : integer range 0 to 4 := 0;
    signal I_A  : std_logic_vector(3 downto 0) := "0000";
    signal I_B  : std_logic_vector(3 downto 0) := "0000";
    signal I_S1 : std_logic_vector(3 downto 0) := "0000";
    signal I_S2 : std_logic_vector(3 downto 0) := "0000";
component ADD4
    port( A : in  std_logic_vector(3 downto 0);
          B : in  std_logic_vector(3 downto 0);
          S : out std_logic_vector(3 downto 0);
          C : out std_logic);
end component;
begin

    process begin
        I_CLK <= '0';
        wait for 10 ns;
        I_CLK <= '1';
        wait for 10 ns;
    end process;

    process(I_CLK)
    begin
        if (I_CLK'event and I_CLK = '1') then
            if (I_CNT = 4) then
                assert false
                report "end." severity FAILURE;
            else
                I_CNT <= I_CNT + 1;
            end if;
        end if;
    end process;

    process(I_CLK)
    begin
        if (I_CLK'event and I_CLK = '1') then
            if I_CNT = 0 then
                I_A <= "0001";
                I_B <= "0001";
            elsif I_CNT = 1 then
                I_A <= "0111";
                I_B <= "0010";
            elsif I_CNT = 2 then
                I_A <= "1110";
                I_B <= "0011";
            end if;
        end if;
    end process;

    U1: ADD4 port map(A => I_A, B => I_B, S => I_S1, C => open);
    I_S2 <= I_A + I_B;

    process(I_CLK)
    variable LO : line;
    begin
        if (I_CLK'event and I_CLK = '1') then
            write(LO, NOW);
            write(LO, string'(" : "));
            hwrite(LO, I_A);
            write(LO, string'("+"));
            hwrite(LO, I_B);
            write(LO, string'("="));
            write(LO, string'(" (S1)"));
            hwrite(LO, I_S1);
            write(LO, string'(" (S2)"));
            hwrite(LO, I_S2);
            if (I_S1 = I_S2) then
                write(LO, string'(" OK"));
            else
                write(LO, string'(" NG"));
            end if;
            writeline(OUTPUT, LO);
        end if;
    end process;

end SIM;
