library IEEE,STD;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use std.TEXTIO.all;
use ieee.std_logic_textio.all;

entity ADD4_TEST is
end ADD4_TEST;

architecture SIM of ADD4_TEST is
    file   INFILE : text is in "test.txt";
    signal I_CLK : std_logic := '1';
    signal I_A   : std_logic_vector(3 downto 0) := "0000";
    signal I_B   : std_logic_vector(3 downto 0) := "0000";
    signal I_S   : std_logic_vector(3 downto 0) := "0000";
component ADD4
    port( A : in  std_logic_vector(3 downto 0);
          B : in  std_logic_vector(3 downto 0);
          S : out std_logic_vector(3 downto 0);
          C : out std_logic);
end component;
begin

    process begin
        I_CLK <= '0';
        wait for 10 ns;
        I_CLK <= '1';
        wait for 10 ns;
    end process;

    process(I_CLK)
    variable LI : line;
    variable VALUE : std_logic_vector(3 downto 0);
    begin
        if (I_CLK'event and I_CLK = '1') then
            if (endfile(INFILE)) then
                assert false report "END" severity FAILURE;
            else
                readline(INFILE, LI);
                read(LI, VALUE);
                I_A <= VALUE;
                read(LI, VALUE);
                I_B <= VALUE;
            end if;
        end if;
    end process;

    U1: ADD4 port map(A => I_A, B => I_B, S => I_S, C => open);

    process(I_CLK)
    variable LO : line;
    begin
        if (I_CLK'event and I_CLK = '1') then
            write(LO, NOW);
            write(LO, string'(" : "));
            hwrite(LO, I_A);
            write(LO, string'("+"));
            hwrite(LO, I_B);
            write(LO, string'("="));
            hwrite(LO, I_S);
            writeline(OUTPUT, LO);
        end if;
    end process;

end SIM;
